require 'MiddleClass.lua'

NineSliceRect = class('NineSliceRect')
function NineSliceRect:initialize(x, y, w, h, folder)
	self.X = x
	self.Y = y
	self.W = w
	self.H = h
	
	self.BG = love.graphics.newImage(folder .. "/bg.png")
	self.TL = love.graphics.newImage(folder .. "/tl.png")
	self.TR = love.graphics.newImage(folder .. "/tr.png")
	self.BL = love.graphics.newImage(folder .. "/bl.png")
	self.BR = love.graphics.newImage(folder .. "/br.png")
	self.Horz = love.graphics.newImage(folder .. "/horz.png")
	self.Vert = love.graphics.newImage(folder .. "/vert.png")
end

function NineSliceRect:GetClientWidth()
	return self.W - (self.Horz:getWidth() * 2)
end

function NineSliceRect:GetClientHeight()
	return self.H - (self.Vert:GetWidth() * 2)
end

function NineSliceRect:draw(R, G, B, A)
	local r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(R, G, B, A)
	love.graphics.draw(self.TL, self.X, self.Y)
	love.graphics.draw(self.Horz, self.X + self.TL:getWidth(), self.Y, 0, (self.W - (self.TL:getWidth() + self.TR:getWidth())) / self.Horz:getWidth(), 1)
	love.graphics.draw(self.TR, self.X + (self.W - self.TR:getWidth()), self.Y)
	love.graphics.draw(self.BG, self.X + self.TL:getWidth(), self.Y + self.TL:getHeight(), 0,
		(self.W - (self.TL:getWidth() + self.TR:getWidth())) / self.BG:getWidth(),
		(self.H - (self.TL:getHeight() + self.TR:getHeight())) / self.BG:getHeight())
	love.graphics.draw(self.BL, self.X, self.Y + (self.H - self.BL:getHeight()))
	love.graphics.draw(self.Vert, self.X, self.Y + self.TL:getHeight(), 0, 1, (self.H - (self.TL:getHeight() + self.BL:getHeight())) / self.Vert:getHeight())
	love.graphics.draw(self.BR, self.X + (self.W - self.BR:getWidth()), self.Y + (self.H - self.BR:getHeight()))
	love.graphics.draw(self.Horz, self.X + self.BL:getWidth(), self.Y + (self.H - self.Horz:getHeight()), 0,
		(self.W - (self.BL:getWidth() + self.BR:getWidth())) / self.Horz:getWidth(), 1)
	love.graphics.draw(self.Vert, self.X + (self.W - self.Vert:getWidth()), self.Y + self.TR:getHeight(), 0,
		1, (self.H - (self.TR:getWidth() + self.BR:getWidth())) / self.Vert:getWidth())
	love.graphics.setColor(r, g, b, a)
 end